# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#

require_relative '../puppet_x/enterprisemodules/pg_secured/facts'

Facter.add("pg_functions_with_excessive_privs") do
    setcode do
      extend Puppet_X::EnterpriseModules::Postgres::Access
      
      query = <<-SQL
      select
      encode(pg_get_functiondef(p.oid)::bytea, 'hex') as prosrc
      from
        pg_proc p,
        pg_language l
      where l.oid = p.prolang
      and l.lanname != 'internal'
      and p.prosecdef = true
      SQL
  
      results =  sql_on_all_databases(query)
      results.collect { |r| { 'name' => Array(r.dig('prosrc')).pack('H*').scan(/CREATE OR REPLACE FUNCTION (.*\))/).first.first, 'db' => r.dig('db')}}
    end
  end

