# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#

require_relative '../puppet_x/enterprisemodules/pg_secured/facts'

#
# The list of roles that have excessive administrative rights
#
pg_secured_fact('roles_with_excessive_admin_privs') {<<-SQL
  select rolname as name from pg_roles
  where rolsuper = 't'
  or rolcreaterole = 't'
  or rolcreatedb = 't'
  or rolreplication = 't'
  or rolbypassrls = 't'
  or rolinherit = 't'
  SQL
}
