# frozen_string_literal: true

#
# See the file "LICENSE" for the full license governing this code.
#
#
# Users added to the pg_wheel group
#
Facter.add(:pg_unsafe_authentication_methods) do
  setcode do
    begin
      version = Facter.value('pg_major_version')
      unsafe_lines = []
      File.readlines("/var/lib/pgsql/#{version}/data/pg_hba.conf").each do |line|
        next if line[0] == '#'
        next if line =~ /^local/
        next unless line =~ /trust|ident|password/
        type, database, user, address, method, option = line.split
        unsafe_lines <<  "%s to %s on %s from %s" % [type, user, database, address]
      end
      unsafe_lines
    rescue NoMethodError, Errno::ENOENT
      []
    end
  end
end
  