#
# See the file "LICENSE" for the full license governing this code.
#
#
# Check all requirements for facts
#
$LOAD_PATH.unshift "#{Puppet.settings[:environmentpath]}/#{Puppet.settings[:environment]}/modules/pg_config/lib"
begin
  require 'puppet_x/enterprisemodules/postgres/fact'
  require 'puppet/feature/postgres_running'
rescue
  Puppet.warn_once(:no_pc_config, 'pg_secured:Facts', 'pg_config not installed; pg_secured facts depend upon pg_config module beeing installed; Skipping pg_secured facts')
  return
end


def pg_secured_fact(fact_name)
  include PuppetX::Postgres::Fact
  include PostgresFeature
  if Puppet.features.postgres_running?
    begin
      require 'entitlement/entitlement'
      ::Entitlement::Entitlement.entitled?("pg_secured#facts##{fact_name}")
      Facter.add("pg_#{fact_name}") do
        pg_array_fact(name: 'name', db: 'db') do
          yield
        end
      end
    rescue
      Puppet.warn_once(:no_pg_secured_entitlements, 'pg_secured:Facts', 'pg_secured not entitled on this node; Skipping pg_secured facts')
      Facter.add("pg_#{fact_name}") do
        setcode { [] } # return an empty value
      end
    end
  else
    Facter.add("pg_#{fact_name}") do
      setcode { [] } # return an empty value
    end
  end
end
